{ jIDEE : Java IDE for Education

  Copyright (C) 2010 Mithat Konar mkonar@dogus.edu.tr

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 3 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}

{%RunFlags BUILD-}
unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Menus, ComCtrls, Buttons, StdCtrls, LCLType, FileCtrl, ExtCtrls,
  IniPropStorage, Process, OpenURLUtil, MiscUtils, UAboutForm, UCompilerResultsForm,
  StrUtils,
  {$IFDEF MSWINDOWS}
  UPreferencesForm_Win;
  {$ELSE}
  {$IFDEF DARWIN}
  UPreferencesForm_OSX;
  {$ELSE}
  {$IFDEF UNIX}
  UPreferencesForm_Linux;
  {$ENDIF}
  {$ENDIF}
  {$ENDIF}

const
  { The following are used in filtering list items in the UI. }
  DEFAULT_SOURCE_EXT =          '.java';
  SOURCE_EXTS_LIST =            '*.java; *.JAVA; '
                              + '*.txt; *.TXT; '
                              + '*.html; *.HTML; '
                              + '*.htm; *.HTM; ';
  COMPILED_SOURCE_EXT =         '*.class';

  { The following are used when creating a new source file. }
  MULTILINE_COMMENT_START =     '/*';
  SOURCE_HEADER_FILENAME =      ' * ';
  SOURCE_HEADER_BLANKLINE =     ' * ';
  SOURCE_HEADER_AUTHOR =        ' * author:  ';
  SOURCE_HEADER_CREATED =       ' * created: ';
  MULTILINE_COMMENT_END =       ' */';

  { Used in "About" window and possibly elsewhere if needed. }
  HOMEPAGE_URL=                 'http://jidee.tuxfamily.org';
  HELP_URL=                     'http://jidee.tuxfamily.org/help/2.0/';
  PROGRAM_VERSION=              '2.0.1';

  { Used in UI to signal "Ask user to enter command line args before running." }
  ALWAYS_ENTER_ARGS_STR=        '//?';

  {$IFDEF MSWINDOWS}
  { Text editor candidates, relative to %ProgramFiles%, i.e.,  C:\Program Files }
  EDITOR_LIST=                  'Programmer''s Notepad\pn.exe,' +
                                'Notepad++\notepad++.exe,' +
                                'jEdit\jedit.bat';
  {$ENDIF}

  {$IFDEF UNIX}
  PRESS_ENTER_TO_CLOSE=         'Press <ENTER> to close...';
  {$IFNDEF DARWIN}
  EDITOR_LIST=                  'geany medit gedit kate bluefish scite'; { Linux only }
  FILEMANAGER_LIST=             'xdg-open nautilus thunar Thunar pcmanfm dolphin rox rox-filer xfe'; { Linux only }
  TEMP_COMPILER_OUTPUT=         '/tmp/jidee_compiler_output';
  {$ENDIF}
  {$ENDIF}

type
{ TODO : Reintroduce context menu operations of file lists once context menu bugs are fixed upstream.
  See http://bugs.freepascal.org/view.php?id=16795 and http://bugs.freepascal.org/view.php?id=16972. }
  { TMainForm }
  TMainForm = class(TForm)
    browseFileDir_button: TBitBtn;
    deleteSelectedSource_button: TBitBtn;
    deleteSource_menuitem: TMenuItem;
    deleteCompiled_menuitem: TMenuItem;
    MenuItem7: TMenuItem;
    commandArgs_menuitem: TMenuItem;
    propstorage_win: TIniPropStorage;
    propstorage_general: TIniPropStorage;
    propstorage_linux: TIniPropStorage;
    runSelected_button: TBitBtn;
    compileSelected_button: TBitBtn;
    edit_menu: TMenuItem;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    browseRoot_menuitem: TMenuItem;
    MenuItem3: TMenuItem;
    browerActive_menuitem: TMenuItem;
    compileFile_menuitem: TMenuItem;
    MenuItem4: TMenuItem;
    editSelected_button: TBitBtn;
    MenuItem5: TMenuItem;
    deleteSelectedClass_button: TBitBtn;
    runSelected_menuitem: TMenuItem;
    refresh_menuitem: TMenuItem;
    MenuItem6: TMenuItem;
    newFile_menuitem: TMenuItem;
    openSource_menuitem: TMenuItem;
    setRoot_menuitem: TMenuItem;
    preferences_menuitem: TMenuItem;
    projectRoot_button: TBitBtn;
    compile_button: TBitBtn;
    browserRoot_button: TBitBtn;
    newFile_button: TBitBtn;
    selectDirectory_dialog: TSelectDirectoryDialog;
    sources_filelistbox: TFileListBox;
    compiled_filelistbox: TFileListBox;
    projectTree_groupbox: TGroupBox;
    file_groupbox: TGroupBox;
    projectName_label: TLabel;
    sources_label: TLabel;
    compiled_label: TLabel;
    file_menu: TMenuItem;
    main_menubar: TMainMenu;
    build_menu: TMenuItem;
    help_menu: TMenuItem;
    about_menuitem: TMenuItem;
    compile_menuitem: TMenuItem;
    homepage_menuitem: TMenuItem;
    compilerInfo_menuitem: TMenuItem;
    progamHelp_menuitem: TMenuItem;
    quit_menuitem: TMenuItem;
    statusBarMain: TStatusBar;
    project_TreeView: TTreeView;
    dblClickKludge_timer: TTimer;
    procedure browerActive_menuitemClick(Sender: TObject);
    procedure browseFileDir_buttonClick(Sender: TObject);
    procedure browseRoot_menuitemClick(Sender: TObject);
    procedure browserRoot_buttonClick(Sender: TObject);
    procedure commandArgs_menuitemClick(Sender: TObject);
    procedure compiled_filelistboxChange(Sender: TObject);
    procedure compiled_filelistboxDblClick(Sender: TObject);
    procedure compiled_filelistboxKeyPress(Sender: TObject; var Key: char);
    procedure compileFile_menuitemClick(Sender: TObject);
    procedure compilerInfo_menuitemClick(Sender: TObject);
    procedure compile_buttonClick(Sender: TObject);
    procedure compile_menuitemClick(Sender: TObject);
    procedure dblClickKludge_timerTimer(Sender: TObject);
    procedure deleteCompiled_menuitemClick(Sender: TObject);
    procedure deleteSelectedClass_buttonClick(Sender: TObject);
    procedure deleteSelectedSource_buttonClick(Sender: TObject);
    procedure deleteSource_menuitemClick(Sender: TObject);
    procedure editSelected_buttonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    //procedure editSource_menuitemClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure homepage_menuitemClick(Sender: TObject);
    procedure newFile_buttonClick(Sender: TObject);
    procedure newFile_menuitemClick(Sender: TObject);
    procedure openSource_menuitemClick(Sender: TObject);
    procedure preferences_menuitemClick(Sender: TObject);
    procedure progamHelp_menuitemClick(Sender: TObject);
    procedure projectName_labelClick(Sender: TObject);
    procedure projectRoot_buttonClick(Sender: TObject);
    procedure about_menuitemClick(Sender: TObject);
    procedure project_TreeViewClick(Sender: TObject);
    procedure project_TreeViewDblClick(Sender: TObject);
    procedure project_TreeViewSelectionChanged(Sender: TObject);
    procedure quit_menuitemClick(Sender: TObject);
    procedure refresh_menuitemClick(Sender: TObject);
    procedure runSelected_menuitemClick(Sender: TObject);
    procedure setRoot_menuitemClick(Sender: TObject);
    procedure sources_filelistboxChange(Sender: TObject);
    procedure sources_filelistboxDblClick(Sender: TObject);
    procedure sources_filelistboxKeyPress(Sender: TObject; var Key: char);
    procedure statusBarMainClick(Sender: TObject);
  private
    { private declarations }
    m_theRoot : String;
    m_activeDir : String;
    m_argStr : String;
    m_preferredEditor : String;

    {$IFDEF MSWINDOWS}
    m_jdkpath : String;                  { Windows only }
    {$ENDIF}
    {$IFDEF UNIX}
    { Linux+OSX only }
    {$IFNDEF DARWIN}
    m_preferredFM : String;              { Linux only }
    {$ENDIF}
    {$ENDIF}

    { support methods }
    procedure OpenDirBrowser();
    procedure SetProjectRoot(newRootDir : String);
    procedure SetActiveDir(newActiveDir : String);
    procedure PopulateProjectTree(theRootDir : String);
    procedure AddDirectoriesToProjectTree(theNode: TTreeNode; inPath: String);         { helper method for PopulateProjectTree }
    procedure OpenProjectRootInFileManager();
    procedure OpenActiveDirInFileManager();
    procedure CreateNewSourceFile();
    procedure DeleteSelectedSourceFile();
    procedure DeleteSelectedCompiledFile();
    procedure DeleteFileWithConfirmation(theFileName : String);
    procedure OpenSelectedSourceFile();
    procedure UpdateFileLists();
    procedure DisableFileControls();
    procedure OpenInExternalFileManager(thePath : String);
    procedure OpenInEditor(thePath : String);
    procedure CompileProjectFromRoot();
    procedure CompileSelectedSourceFile();
    procedure Compile(const theDir : String; const theFile : String = '*.java');
    procedure RunSelectedCompiledFile();
    procedure SaveConfigs();
    procedure LoadConfigs();
    procedure ShowPreferencesForm();
    procedure SetCommandLineArgs();
    function CaptureExternalProcess(theCommand : String) : String;
    {$IFDEF MSWINDOWS}
    function GetCompilerExe() : String;                  { Windows only }
    function FindJDKpath() : String;                     { Windows only }
    {$ENDIF}
  public
    { public declarations }
    { properties }
    property ProjectRoot : String  { the root directory of the project }
      read m_theRoot write SetProjectRoot;
    property ActiveDir : String   { the directory selected in the project tree }
      read m_activeDir write SetActiveDir;
  end; 

var
  MainForm: TMainForm;

{==============================================================================}
implementation

{ TMainForm }

procedure TMainForm.quit_menuitemClick(Sender: TObject);
begin
  close;
end;

procedure TMainForm.refresh_menuitemClick(Sender: TObject);
begin
  self.ProjectRoot:=m_theRoot;
  self.UpdateFileLists();
end;

procedure TMainForm.runSelected_menuitemClick(Sender: TObject);
begin
  self.RunSelectedCompiledFile();
end;

procedure TMainForm.setRoot_menuitemClick(Sender: TObject);
begin
  self.OpenDirBrowser();
end;

procedure TMainForm.sources_filelistboxChange(Sender: TObject);
begin
  if self.sources_filelistbox.SelCount > 0 then
  begin
{ Workaround for behavior bug:
  when list is first made, there is nothing selected. When the first selection
  is made, sometimes we don't seem to end up inside sources_filelistboxChange.
  So, OnClick is diverted here as well. }
    self.editSelected_button.Enabled:=true;
    self.openSource_menuitem.Enabled:=true;
    self.compileSelected_button.Enabled:=true;
    self.compileFile_menuitem.Enabled:=true;
    self.deleteSource_menuitem.Enabled:=true;
    self.deleteSelectedSource_button.Enabled:=true;
  end
end;

procedure TMainForm.sources_filelistboxDblClick(Sender: TObject);
begin
  if self.sources_filelistbox.SelCount > 0 then
    self.OpenSelectedSourceFile();
end;

procedure TMainForm.sources_filelistboxKeyPress(Sender: TObject; var Key: char);
begin
  { capture ENTER keypresses }
  if Key in [#13, #10] then
  //if Key = LineEnding then
  { TODO : Recode after confirming freepascal booleans short circuit. }
    if self.sources_filelistbox.SelCount = 1 then
      self.OpenSelectedSourceFile();
end;

procedure TMainForm.statusBarMainClick(Sender: TObject);
begin
  self.OpenActiveDirInFileManager();
end;

procedure TMainForm.projectRoot_buttonClick(Sender: TObject);
begin
  self.OpenDirBrowser();
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  // create a dir for setting if needed
  if not DirectoryExistsUTF8(GetAppConfigDirUTF8(False)) then
    if not CreateDirUTF8(GetAppConfigDirUTF8(False)) then
      MessageDlg ('jIDEE Configuration Directory Error',
              'I was not able to create a directory for saving jIDEE settings. '+
              'This is not normal, and you should try to fix this problem.'+LineEnding+
              LineEnding+
              'The directory I could not create is:' + LineEnding +
              GetAppConfigDirUTF8(False),
              mtError, [mbOK],0);

  self.propstorage_general.IniFileName:=GetAppConfigDir(False)+'settings.ini';
  self.propstorage_win.IniFileName:=self.propstorage_general.IniFileName;
  self.propstorage_linux.IniFileName:=self.propstorage_general.IniFileName;

  self.sources_filelistbox.Mask:=SOURCE_EXTS_LIST;
  self.compiled_filelistbox.Mask:=COMPILED_SOURCE_EXT;
  self.m_argStr:='';
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  self.LoadConfigs();
end;

procedure TMainForm.homepage_menuitemClick(Sender: TObject);
begin
  OpenURL(HOMEPAGE_URL);
end;

procedure TMainForm.newFile_buttonClick(Sender: TObject);
begin
  self.CreateNewSourceFile();
end;

procedure TMainForm.newFile_menuitemClick(Sender: TObject);
begin
  self.CreateNewSourceFile();
end;

procedure TMainForm.openSource_menuitemClick(Sender: TObject);
begin
  self.OpenSelectedSourceFile();
end;

procedure TMainForm.preferences_menuitemClick(Sender: TObject);
begin
  self.ShowPreferencesForm;
end;

procedure TMainForm.progamHelp_menuitemClick(Sender: TObject);
begin
  OpenURL(HELP_URL);
end;

procedure TMainForm.projectName_labelClick(Sender: TObject);
begin
  self.OpenDirBrowser();
end;

procedure TMainForm.browseFileDir_buttonClick(Sender: TObject);
begin
  self.OpenActiveDirInFileManager();
end;

procedure TMainForm.browerActive_menuitemClick(Sender: TObject);
begin
  self.OpenActiveDirInFileManager();
end;

procedure TMainForm.browseRoot_menuitemClick(Sender: TObject);
begin
  self.OpenProjectRootInFileManager();
end;

procedure TMainForm.browserRoot_buttonClick(Sender: TObject);
begin
  self.OpenProjectRootInFileManager();
end;

procedure TMainForm.commandArgs_menuitemClick(Sender: TObject);
begin
  self.SetCommandLineArgs();
end;

procedure TMainForm.compiled_filelistboxChange(Sender: TObject);
{ Workaround for behavior bug:
  When list is first made, there is nothing selected. When the first selection
  is made, sometimes in the sources listbox we don't seem to end up inside
  sources_filelistboxChange. So, OnClick is diverted here as well (prophylactically). }
begin
  if self.compiled_filelistbox.SelCount > 0 then
  begin
    self.runSelected_button.Enabled:=true;
    self.runSelected_menuitem.Enabled:=true;
    self.deleteSelectedClass_button.Enabled:=true;
    self.deleteCompiled_menuitem.Enabled:=true;
  end;
end;

procedure TMainForm.compiled_filelistboxDblClick(Sender: TObject);
{ this code includes a workaround for what appears to be a bug in the
  double-click handling for lists }
begin
  //if the kludgeTimer is NOT running ...
  if not self.dblClickKludge_timer.Enabled then
    if self.compiled_filelistbox.SelCount > 0 then
    begin
      self.RunSelectedCompiledFile();
      self.dblClickKludge_timer.Enabled:=true;    { enable timer to disable future events }
    end;
end;

procedure TMainForm.compiled_filelistboxKeyPress(Sender: TObject; var Key: char
  );
begin
  { capture ENTER keypresses }
  if Key in [#13, #10] then
  //if Key = LineEnding then
  { TODO : Recode after confirming freepascal booleans short circuit. }
    if self.compiled_filelistbox.SelCount = 1 then
      self.RunSelectedCompiledFile();
end;

procedure TMainForm.compileFile_menuitemClick(Sender: TObject);
begin
  self.CompileSelectedSourceFile();
end;

procedure TMainForm.compilerInfo_menuitemClick(Sender: TObject);
var
  JREinfo, CompilerInfo : String;
  dialogType : TMsgDlgType;
begin
  dialogType:=mtInformation;

  {$IFDEF MSWINDOWS}
  JREinfo:=self.CaptureExternalProcess('javaw -version');
  {$ELSE}
  JREinfo:=self.CaptureExternalProcess('java -version');
  {$ENDIF}

  if length(JREinfo) = 0 then
  begin
    JREinfo:='Error: not found';
    dialogType:=mtError;
  end;

  {$IFDEF MSWINDOWS}
  CompilerInfo:=self.CaptureExternalProcess(self.GetCompilerExe() + ' -version');
  {$ELSE}
  CompilerInfo:=self.CaptureExternalProcess('javac -version');
  {$ENDIF}

  if length(CompilerInfo) = 0 then
  begin
    CompilerInfo:='Error: not found';
    dialogType:=mtError;
  end;

  MessageDlg ('Environment information',
              'Runtime: ' + LineEnding + JREinfo + LineEnding +
              'Compiler:' + LineEnding + CompilerInfo,
              dialogType, [mbOk],0)
end;

//procedure TMainForm.editSource_menuitemClick(Sender: TObject);
//begin
//{ This incorporates a workaround for the TFileListBox.Filename bug. }
//  self.OpenInEditor(self.sources_filelistbox.Directory+DirectorySeparator+self.sources_filelistbox.Items[self.sources_filelistbox.ItemIndex]);
//end;

procedure TMainForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  self.SaveConfigs();
end;

procedure TMainForm.compile_buttonClick(Sender: TObject);
begin
  self.CompileProjectFromRoot();
end;

procedure TMainForm.compile_menuitemClick(Sender: TObject);
begin
  self.CompileProjectFromRoot();
end;

procedure TMainForm.dblClickKludge_timerTimer(Sender: TObject);
// This is part of a workaround for what appears to be a double-click
// but in lists. The idea is to disable events that happen to soon
// after an event is handled.
begin
  self.dblClickKludge_timer.Enabled:=false;
end;

procedure TMainForm.deleteCompiled_menuitemClick(Sender: TObject);
begin
  self.DeleteSelectedCompiledFile();
end;

procedure TMainForm.deleteSelectedClass_buttonClick(Sender: TObject);
begin
  self.DeleteSelectedCompiledFile();
end;

procedure TMainForm.deleteSelectedSource_buttonClick(Sender: TObject);
begin
  self.DeleteSelectedSourceFile();
end;

procedure TMainForm.deleteSource_menuitemClick(Sender: TObject);
begin
  self.DeleteSelectedSourceFile();
end;

procedure TMainForm.editSelected_buttonClick(Sender: TObject);
begin
  self.OpenSelectedSourceFile();
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
//  self.UpdateFileLists();
end;

procedure TMainForm.about_menuitemClick(Sender: TObject);
begin
  AboutForm.versionLabel.Caption:=PROGRAM_VERSION;
  AboutForm.ShowModal();
end;

procedure TMainForm.project_TreeViewClick(Sender: TObject);
begin
  self.UpdateFileLists();
end;

procedure TMainForm.project_TreeViewDblClick(Sender: TObject);
begin
//  self.OpenInExternalFileManager(self.project_TreeView.Selected.GetTextPath);
  self.OpenActiveDirInFileManager();
end;

procedure TMainForm.project_TreeViewSelectionChanged(Sender: TObject);
var
  theTextPath : String;
begin
  theTextPath:=self.project_TreeView.Selected.GetTextPath;
  DoDirSeparators(theTextPath);
  self.SetActiveDir(theTextPath);
end;

{=================================}
{======== support methods ========}
{=================================}

procedure TMainForm.OpenDirBrowser();
{ TODO : Rewrite OpenDirBrowser to loop until directory successfully set. }
begin
  if self.selectDirectory_dialog.Execute() then
    self.ProjectRoot:=self.selectDirectory_dialog.FileName;
end;

procedure TMainForm.SetProjectRoot(newRootDir : String);
begin
  //if not DirectoryExistsUTF8(newRootDir) then
  //begin
  //  MessageDlg ('Directory not found',
  //              'The directory ' + newRootDir +' was not found on this system',
  //              mtError, [mbOk],0);
  //  exit;
  //end;

  if newRootDir+DirectorySeparator = SysToUTF8(GetUserDir()) then
  begin
    MessageDlg ('Directory not allowed',
                'You cannot use your home directory as a jIDEE project root.',
                mtError, [mbOk],0);
    exit;
  end;

  if newRootDir = SysToUTF8(GetFSRoot()) then
  begin
    MessageDlg ('Directory not allowed',
                'You cannot use the system root as a jIDEE project root.',
                mtError, [mbOk],0);
    exit;
  end;

  { TODO : remove from OS X? }
  { This is imperfect on non-English OSes, but it's the best we can do. }
  if newRootDir = SysToUTF8(GetUserDir()+'Desktop') then
  begin
    MessageDlg ('Directory not allowed',
                'You cannot use your Desktop as a jIDEE project root.',
                mtError, [mbOk],0);
    exit;
  end;

  { TODO : remove from OS X? }
  { This is imperfect on non-English OSes, but it's the best we can do. }
  if newRootDir = SysToUTF8(GetUserDir()+'Documents') then
  begin
    MessageDlg ('Directory not allowed',
                'You cannot use your Documents directory as a jIDEE project root.',
                mtError, [mbOk],0);
    exit;
  end;

  self.m_theRoot:=newRootDir;
  self.projectName_label.Caption:=ExtractFileName(self.m_theRoot);  { set project label }
  self.projectName_label.Hint:='Project root: '+LineEnding+self.m_theRoot;    { set project label's hint }
  self.PopulateProjectTree(self.m_theRoot);                         { update the project tree }
  self.SetActiveDir(newRootDir);
  self.selectDirectory_dialog.FileName:=self.m_theRoot;
end;

procedure TMainForm.SetActiveDir(newActiveDir : String);
begin
  //if not DirectoryExistsUTF8(newActiveDir) then
  //begin
  //  MessageDlg ('Directory not found',
  //              'The directory ' + newActiveDir +' was not found on this system',
  //              mtError, [mbOk],0);
  //  exit;
  //end;

  self.m_activeDir:=newActiveDir;
  self.sources_filelistbox.Directory:=self.m_activeDir;        { the sources list }
  self.compiled_filelistbox.Directory:=self.m_activeDir;       { the compiled list }
  //self.UpdateFileLists();
  self.DisableFileControls();
  self.statusBarMain.Panels.Items[0].Text:=self.m_activeDir;   { set status bar }
  self.statusBarMain.Hint:='Active directory: '+LineEnding+self.m_activeDir;
 end;

procedure TMainForm.UpdateFileLists();
begin
  { updating file lists de-selects whatever was selected, so we must also
    disable related buttons and menu items }
  self.sources_filelistbox.UpdateFileList;
  self.compiled_filelistbox.UpdateFileList;
  self.DisableFileControls();
end;

procedure TMainForm.DisableFileControls();
begin
  { disables controls related to editing, compiling and running files }
  self.editSelected_button.Enabled:=false;
  self.openSource_menuitem.Enabled:=false;
  self.compileSelected_button.Enabled:=false;
  self.compileFile_menuitem.Enabled:=false;
  self.deleteSource_menuitem.Enabled:=false;
  self.deleteSelectedSource_button.Enabled:=false;

  self.runSelected_button.Enabled:=false;
  self.runSelected_menuitem.Enabled:=false;
  self.deleteSelectedClass_button.Enabled:=false;
  self.deleteCompiled_menuitem.Enabled:=false;
end;

procedure TMainForm.PopulateProjectTree(theRootDir : String);
{ Populate project_TreeView with the root specified in theRootDir }
{ TODO : (PopulateProjectTree) Convert to SysToUTF8 / UTF8ToSys functions? }
var
  searchRec : TSearchRec;
  FileAttrs : Integer;
  theRootNode : TTreeNode;
  aNode : TTreeNode;
begin
  FileAttrs := faDirectory;     // Only care about directories
  project_TreeView.Items.Clear;
  theRootNode := project_TreeView.Items.AddFirst(nil,theRootDir);
  theRootNode.ImageIndex:=0;
  project_TreeView.Items.BeginUpdate();
  if FindFirst(theRootDir + DirectorySeparator + '*', FileAttrs, searchRec) = 0 then
  begin
    repeat
      if (searchRec.Name = '.') or (searchRec.Name = '..') then
        continue;
      if (searchRec.Attr and faVolumeID) = faVolumeID then
        continue; // nothing useful to do with volume IDs
      if (searchRec.Attr and faHidden) = faHidden then
        continue; // honor the OS "hidden" setting ... doesn't seem to work in Linux
      if (searchRec.Attr and FileAttrs) = FileAttrs then              { we've found a directory! }
      begin
        aNode := project_TreeView.Items.AddChild(theRootNode,searchRec.name);  { add it as a node to the tree }
        //aNode.ImageIndex:=0;
        AddDirectoriesToProjectTree(aNode,theRootDir+DirectorySeparator+searchRec.Name);  { and add its subdirs as children }
      end;
    until FindNext(searchRec) <> 0;
    FindClose(searchRec);
  end;
  project_TreeView.Items.EndUpdate();
  project_TreeView.AlphaSort();
  //project_TreeView.FullExpand();
end;

procedure TMainForm.AddDirectoriesToProjectTree(theNode: TTreeNode; inPath: String);
{ TODO : (AddDirectoriesToProjectTree) Convert to SysToUTF8 / UTF8ToSys functions? }
var
  searchRec : TSearchRec;
  FileAttrs : Integer;
  theNewNode : TTreeNode;
begin
  FileAttrs := faDirectory;     // Only care about directories
  if FindFirst(inPath + DirectorySeparator + '*', FileAttrs, searchRec) = 0 then
  begin
    repeat
      //if  ((searchRec.Attr and FileAttrs) = searchRec.Attr) and (copy(searchRec.Name,1,1) <> '.') then
      if (searchRec.Name = '.') or (searchRec.Name = '..') then
        continue;
      if (searchRec.Attr and faHidden) = faHidden then
        continue; // honor the OS "hidden" setting ... doesn't seem to work in Linux?
      if  ((searchRec.Attr and FileAttrs) = FileAttrs) then            { we've found a directory! }
      begin
        theNewNode := project_TreeView.Items.AddChild(theNode,searchRec.name);  { add it as a node to the tree }
        //theNewNode.ImageIndex:=0;
        self.AddDirectoriesToProjectTree(theNewNode,inPath+DirectorySeparator+searchRec.Name);  { and add its subdirs as children }
      end;
    until FindNext(searchRec) <> 0;
    FindClose(searchRec);
  end;
end;

procedure TMainForm.OpenProjectRootInFileManager();
begin
  self.OpenInExternalFileManager(self.ProjectRoot);
end;

procedure TMainForm.OpenActiveDirInFileManager();
begin
  self.OpenInExternalFileManager(self.ActiveDir);
end;

procedure TMainForm.OpenSelectedSourceFile();
begin
  if self.sources_filelistbox.SelCount = 1 then
    self.OpenInEditor(self.sources_filelistbox.FileName)
  else
    MessageDlg ('No file selected', 'You must first select a file from the Sources list.', mtError,
                 [mbOk],0)
end;

procedure TMainForm.CreateNewSourceFile();
var
  theFileName : String;
  theFile : TextFile;
  newFile_dialog : TSaveDialog;
begin
{ TODO : TSaveDialog.InitialDir seems to set once but in further invocations
  seems to be ignored. Find a workaround, e.g. create the  TSaveDialog locally. }
  newFile_dialog:=TSaveDialog.Create(self);
  newFile_dialog.Options:=[ofOverwritePrompt, ofEnableSizing];
  newFile_dialog.DefaultExt:=DEFAULT_SOURCE_EXT;
  newFile_dialog.FileName:='newFile'+DEFAULT_SOURCE_EXT;
  newFile_dialog.InitialDir:=self.ActiveDir;
  newFile_dialog.Title:='Create new source file';
  if newFile_dialog.Execute() then
  begin
    theFileName:=UTF8ToSys(newFile_dialog.FileName);
    try
      //try
        AssignFile(theFile, theFileName);
        Rewrite(theFile);
        if ExtractFileExt(theFileName) = DEFAULT_SOURCE_EXT then
        begin
          Write(theFile,
                UTF8ToConsole(MULTILINE_COMMENT_START + LineEnding +
                SOURCE_HEADER_FILENAME + ExtractFilename(theFileName) +LineEnding +
                SOURCE_HEADER_BLANKLINE +LineEnding +
                SOURCE_HEADER_AUTHOR + tiGetUserName() +LineEnding +
                SOURCE_HEADER_CREATED + DateTimeToStr(Now()) +LineEnding +
                SOURCE_HEADER_BLANKLINE +LineEnding +
                MULTILINE_COMMENT_END));
        end;
        Writeln(theFile, '');
      //finally
        CloseFile(theFile);
      //end;
      self.UpdateFileLists();
      self.OpenInEditor(newFile_dialog.FileName); { note that the filename should be the UTF8 in this call }
    except
      on E: Exception do
      MessageDlg ('File Error',
                  E.Message+LineEnding+
                  'Possible reasons include:'+LineEnding+
                  ' * You do not have permission to write in this directory.'+LineEnding+
                  ' * The disc is full.'+LineEnding+
                  ' * Hardware or network failure.',
                  mtError, [mbOk],0);
    end;
  end;
  newFile_dialog.Destroy;
end;

procedure TMainForm.DeleteSelectedSourceFile();
begin
  DeleteFileWithConfirmation(self.sources_filelistbox.FileName);
end;

procedure TMainForm.DeleteSelectedCompiledFile();
begin
  DeleteFileWithConfirmation(self.compiled_filelistbox.FileName);
end;

procedure TMainForm.DeleteFileWithConfirmation(theFileName : String);
{theFileName is assumed to be UTF8; it is converted to system when system call
is made. }
begin
  if MessageDlg ('Confirm delete',
                 'Really delete ' + theFileName + ' ?',
                 mtConfirmation, [mbYes, mbNo],0) = mrYes then
  begin
    if not DeleteFile(UTF8ToSys(theFileName)) then
      MessageDlg('File Error',
                  'For some reason, I wasn''t able to delete'+LineEnding+
                  theFileName + ' .',
                  mtError, [mbOk],0);
    self.UpdateFileLists();
  end;
end;

function TMainForm.CaptureExternalProcess( theCommand : String ) : String;
{ Executes external theCommand and returns result. If theCommand is not found or
  produces an exception, returns empty string. theCommand is assumed to be UTF8.
  Don't use this for long processes or ones that have a danger of hanging. }
var
  InfoProcess : TProcess;
  InfoStringList : TStringList;
  InfoResult : String;
begin
    InfoProcess := TProcess.Create(nil);
    InfoStringList := TStringList.Create;

    InfoProcess.CommandLine := UTF8ToSys(theCommand);
    InfoProcess.Options := InfoProcess.Options + [poWaitOnExit, poUsePipes, poStderrToOutPut];
  try
    InfoProcess.Execute;

    InfoStringList.LoadFromStream(InfoProcess.Output);
    InfoResult:=InfoStringList.Text;
    result:=InfoResult;
  except
    result:='';
  end;
  InfoStringList.Free;
  InfoProcess.Free;
end;

procedure TMainForm.CompileProjectFromRoot();
begin
  self.Compile(self.ProjectRoot);
  //self.UpdateFileLists();
end;

procedure TMainForm.CompileSelectedSourceFile();
begin
  if self.sources_filelistbox.SelCount = 1 then
  begin
    {$IFDEF Windows}
    { TODO : Test whether spaces are OK in 2nd argument with Windows. }
    self.Compile(self.ProjectRoot, self.sources_filelistbox.FileName);
    {$ELSE}
    {$IFDEF UNIX}
    self.Compile(self.ProjectRoot, ''''+self.sources_filelistbox.FileName+'''');
    {$ENDIF}
    {$ENDIF}
    //self.UpdateFileLists();
  end
  else
    MessageDlg ('No file selected', 'You must first select a file from the Sources list.', mtError,
                 [mbOk],0)
end;

procedure TMainForm.SetCommandLineArgs();
var
  args : String;
begin
  args:=self.m_argStr;
  if InputQuery('Set command line arguments: ' +
    ExtractFileName(self.compiled_filelistbox.FileName),
    'Command line arguments:', args) then
    self.m_argStr:=args;
end;

{==============================================================================}
{=== The following section has most of the target dependent stuff =============}
{==============================================================================}

{===============================================================}
{=== Stuff with target deps internimgled =======================}
{===============================================================}
procedure TMainForm.SaveConfigs();
begin
  self.propstorage_general.StoredValue['project_root'] := UTF8ToSys(self.ProjectRoot);
  {$IFDEF MSWINDOWS}
  self.propstorage_win.StoredValue['editor'] := UTF8ToSys(self.m_preferredEditor);   { Windows only }
  self.propstorage_win.StoredValue['jdk_path'] := UTF8ToSys(self.m_jdkpath);         { Windows only }
  {$ENDIF}
  {$IFDEF UNIX}
  {$IFNDEF DARWIN}
  self.propstorage_linux.StoredValue['editor'] := UTF8ToSys(self.m_preferredEditor);         { Linux only }
  self.propstorage_linux.StoredValue['filemanager'] := UTF8ToSys(self.m_preferredFM);        { Linux only }
  {$ENDIF}
  {$ENDIF}
end;

procedure TMainForm.LoadConfigs();
var
  iniProjRoot : String;
  N : Integer;
begin
  { ProjectDir }
  iniProjRoot :=SysToUTF8(self.propstorage_general.StoredValue['project_root']);

  if not DirectoryExistsUTF8(iniProjRoot) then
  begin
    MessageDlg ('jIDEE: Invalid Project Directory',
                'The Project Directory is either not set or doesn''t exist.'+LineEnding+
                LineEnding+
                 'This is normal if this is the first time you are running jIDEE.'+LineEnding+
                 LineEnding+
                 'In the following dialog, select or make a directory to contain'+LineEnding+
                 'your project.',
                mtWarning, [mbOk],0);
    self.selectDirectory_dialog.InitialDir:=SysToUTF8(GetUserDir());
    self.OpenDirBrowser();
  end
  else if iniProjRoot+DirectorySeparator = SysToUTF8(GetUserDir()) then
  begin
    MessageDlg ('Directory not allowed',
                'You cannot use your home directory as a jIDEE project root.'
                +LineEnding+
                 'In the following dialog, select a valid Project Directory.',
                mtError, [mbOk],0);
    self.OpenDirBrowser();
  end
  else if iniProjRoot = SysToUTF8(GetFSRoot()) then
    begin
      MessageDlg ('Directory not allowed',
                  'You cannot use the system root as a jIDEE project root.'
                  +LineEnding+
                 'In the following dialog, select a valid Project Directory.',
                  mtError, [mbOk],0);
      self.OpenDirBrowser();
    end
  else
    self.ProjectRoot:=iniProjRoot;

  {$IFDEF MSWINDOWS}
  { if the specified editor doesn't exist, pick one that does. }
  m_preferredEditor:=SysToUTF8(self.propstorage_win.StoredValue['editor']);
  if not FileExistsUTF8(m_preferredEditor) then
  begin
  { iterate over editor candidates until one is found. }
    for N := 1 to WordCount(EDITOR_LIST, [',']) do
    begin
      m_preferredEditor:=GetEnvironmentVariableUTF8('ProgramFiles')+'\'+ExtractWord(N, EDITOR_LIST, [',']);
      if FileExistsUTF8(m_preferredEditor) then
        break
      else
        m_preferredEditor:='notepad';
    end;
  end;
  { if the path to the JDK isn't valid, set a new one. }
  self.m_jdkpath:=SysToUTF8(self.propstorage_win.StoredValue['jdk_path']);
  if not FileExistsUTF8(self.GetCompilerExe()) then  { if self.m_jdkpath\bin\javac doesn't exist }
    self.m_jdkpath:=FindJDKpath();
  if not FileExistsUTF8(self.GetCompilerExe()) then  { if FindJDKpath() couldn't find it }
  begin
    self.m_jdkpath:=GetEnvironmentVariableUTF8('ProgramFiles')+'\Java';
    MessageDlg('jIDEE: Invalid or unspecified JDK',
      'The path to the Java Development Kit (JDK) is either not set or is not valid.'+LineEnding+
      LineEnding+
      'You must install a JDK to use jIDEE. Install a JDK and restart jIDEE.'+LineEnding+
      LineEnding+
      'If you have installed a JDK but still see this message, ' +
      'then set the path to the JDK in the next window.',
      mtWarning, [mbOk],0);
    self.ShowPreferencesForm();
  end;
  {$ENDIF}

  {$IFDEF UNIX}
  {$IFNDEF DARWIN}
  { Linux only }
  { if the specified editor doesn't exist, pick one that does. }
  m_preferredEditor:=SysToUTF8(self.propstorage_linux.StoredValue['editor']);
  if Length(self.CaptureExternalProcess('which '+m_preferredEditor))=0 then
  begin
  { iterate over editor candidates until one is found. }
    for N := 1 to WordCount(EDITOR_LIST, StdWordDelims) do
    begin
      m_preferredEditor:=ExtractWord(N, EDITOR_LIST, StdWordDelims);
      if Length(self.CaptureExternalProcess('which '+m_preferredEditor))>0 then break
    end;
  end;

  { if the specified file manager doesn't exist, pick one that does. }
  m_preferredFM:=SysToUTF8(self.propstorage_linux.StoredValue['filemanager']);
  if Length(self.CaptureExternalProcess('which '+m_preferredFM))=0 then
  begin
  { iterate over filemanager candidates until one is found. }
    for N := 1 to WordCount(FILEMANAGER_LIST, StdWordDelims) do
    begin
      m_preferredFM:=ExtractWord(N, FILEMANAGER_LIST, StdWordDelims);
      if Length(self.CaptureExternalProcess('which '+m_preferredFM))>0 then break
    end;
  end;
  { end Linux only }
  {$ENDIF}
  {$ENDIF}
end;

procedure TMainForm.OpenInExternalFileManager(thePath : String);
{ thePath is assumed to be UTF8 }
var
  FMProcess : TProcess;
begin
  if DirectoryExistsUTF8(thePath) then
  begin
    FMProcess := TProcess.Create(nil);
    {$IFDEF MSWINDOWS}
    FMProcess.CommandLine := 'explorer';
    {$ELSE}
    {$IFDEF UNIX}
    {$IFDEF DARWIN}
    FMProcess.CommandLine := 'open';
    {$ELSE}
    FMProcess.CommandLine := m_preferredFM;
    {$ENDIF}
    {$ENDIF}
    {$ENDIF}
    FMProcess.CommandLine := FMProcess.CommandLine + ' "'+UTF8ToSys(thePath)+'"';
    FMProcess.Execute;
    FMProcess.Free;
  end
  else
    MessageDlg ('No such directory',
                'The directory' + LineEnding + thePath + LineEnding +' does not exist.',
                 mtError, [mbOk],0)
end;

procedure TMainForm.OpenInEditor(thePath : String);
{ thePath is assumed to be UTF8 }
var
  EditorProcess : TProcess;
begin
{ TODO : Put this into an exception? }
  if FileExistsUTF8(thePath) then
  begin
    EditorProcess := TProcess.Create(nil);
    {$IFDEF MSWINDOWS}
    EditorProcess.CommandLine := '"'+m_preferredEditor+'"';
    {$ELSE}
    EditorProcess.CommandLine := m_preferredEditor;
    {$ENDIF}
    EditorProcess.CommandLine := EditorProcess.CommandLine + ' "'+UTF8ToSys(thePath)+'"';
    EditorProcess.Execute;
    EditorProcess.Free;
  end
  else
    MessageDlg ('No such file',
                'The file' + LineEnding + thePath + LineEnding +' does not exist.',
                 mtError, [mbOk],0)
end;

{$IFDEF MSWINDOWS}
{===============================================================}
{=== Windows implementations ===================================}
{===============================================================}

procedure TMainForm.Compile(const theDir : String; const theFile : String = '*.java');
{ theDir and theFile are assumed to be UTF8 }
var
  theFileName : String;
begin
  theFileName:=ExtractFileName(theFile);
  CompilerResultsForm.output_memo.Text:='Compiling '+ theFileName + '...';
  CompilerResultsForm.Show;

  if CompareStr(theFile, '*.java')= 0 then         { add quotes as needed }
    theFileName := theFile
  else
    theFileName := '"'+theFile +'"';
  SetCurrentDir(theDir);
  CompilerResultsForm.output_memo.Text:=self.CaptureExternalProcess(self.GetCompilerExe()+' '+theFileName);
  self.UpdateFileLists();
  if length(CompilerResultsForm.output_memo.Text) = 0 then
    CompilerResultsForm.output_memo.Text:=
      'Done compiling '+ theFileName + LineEnding +
      'No errors or warnings.';

  CompilerResultsForm.FormStyle:=fsStayOnTop;     { kludge seems to work to make sure results form is on top after compile is done }
  //CompilerResultsForm.Show;
  CompilerResultsForm.FormStyle:=fsNormal;        { end of kludge }
end;

procedure TMainForm.RunSelectedCompiledFile();
var
  args : String;         { local buffer for getting command line arguments }
  theClass : String;     { stores the class name without extension }
  ExeProcess : TProcess;
  theCommands : String;
  theBatchFile : String;
  theFile : TextFile;
  runIt : Boolean;
begin
  if self.compiled_filelistbox.SelCount = 1 then
  begin
    runIt:=true;                        { assume we will run the file }

    { get the filename relative to the project root, and then strip off the file extention }
    theClass:=StringReplace(self.compiled_filelistbox.FileName, self.ProjectRoot+DirectorySeparator, '', []);
    theClass:=ChangeFileExt(theClass, '');
    { replace '\' with '/'}
    theClass:=StringReplace(theClass, DirectorySeparator,'/', [rfReplaceAll]);
    { Get commandline args from user if needed. }
    if CompareStr(self.m_argStr, ALWAYS_ENTER_ARGS_STR) = 0 then
    begin
      args:='';
      if not InputQuery(ExtractFileName(self.compiled_filelistbox.FileName) + ' arguments',
        'Command line arguments:', args) then
        runIt:=false
    end
    else
      args:=self.m_argStr;

    if runIt then
    begin
      theCommands :=
        '@echo off' + LineEnding +
        'REM: This is a temporary file created by jIDEE.' + LineEnding +
        'REM: It should have been deleted automatically.' + LineEnding +
        'REM: Feel free to delete this manually.' + LineEnding +
        'title ' + theClass + LineEnding +
        'cd "' + self.ProjectRoot + '"' + LineEnding;
      theCommands +=
        'java -classpath "' + self.ProjectRoot + '" ' + theClass + ' ' + args + LineEnding;
      theCommands +=
        'echo.' + LineEnding +
        'echo.' + LineEnding +
        'pause';
      { create batch file with above commands}
      theBatchFile:=UTF8ToSys(self.ActiveDir+ DirectorySeparator +'jideeTemp.bat');
      try
        AssignFile(theFile, theBatchFile);
        Rewrite(theFile);
        Write(theFile, UTF8ToConsole(theCommands));
        CloseFile(theFile);
      except
        on E: Exception do
          MessageDlg ('File Error',
                    E.Message+LineEnding+
                    'Possible reasons include:'+LineEnding+
                    ' * You do not have permission to write in this directory.'+LineEnding+
                    ' * The disc is full.'+LineEnding+
                    ' * Hardware or network failure.',
                    mtError, [mbOk],0);
      end;
      { execute batch file }
      ExeProcess := TProcess.Create(nil);
      ExeProcess.CommandLine := theBatchFile;
      ExeProcess.Options:=ExeProcess.Options+[poWaitOnExit];
      ExeProcess.Execute;
      ExeProcess.Free;
      { delete batch file }
      DeleteFile(theBatchFile);
    end
  end
  else
    MessageDlg ('No file selected', 'You must first select a file.', mtError,
                 [mbOk],0)
end;

procedure TMainForm.ShowPreferencesForm();
var
  diaResult : Integer;
begin
  { TODO : Do this better ... with enable/disable OK button and/or other indication that things are good. }
  PreferencesForm.jdkpath_directoryedit.Directory:=self.m_jdkpath;
  PreferencesForm.editorpath_filenameedit.FileName:=self.m_preferredEditor;
  diaResult:=PreferencesForm.ShowModal;
  while (diaResult = mrOK) AND (not PreferencesForm.IsJDKPathValid())
  do begin
    MessageDlg ('Invalid JDK path',
        'The selected JDK path is not valid.'+LineEnding+
        LineEnding+
        'Please select a valid path.',
        mtError, [mbOk],0);
    diaResult:=PreferencesForm.ShowModal();
  end;
  while (diaResult = mrOK) AND (not PreferencesForm.IsEditorValid())
  do begin
    MessageDlg ('Editor does not exist',
        'The specifed text editor does not exist.'+LineEnding+
        LineEnding+
        'Please select a valid executable or enter "notepad" to use Notepad.',
        mtError, [mbOk],0);
    diaResult:=PreferencesForm.ShowModal();
  end;
  if diaResult = mrOK then
  begin
    self.m_jdkpath:=PreferencesForm.jdkpath_directoryedit.Directory;
    self.m_preferredEditor:=PreferencesForm.editorpath_filenameedit.FileName;
  end;
end;

function TMainForm.GetCompilerExe() : String;
{ return absolute path to compiler }
begin
  result:=self.m_jdkpath+'\bin\javac.exe';
end;

function TMainForm.FindJDKpath() : String;
{ Returns string of dir containing a JDK or empty string if not found.
  Visits all ProgramFiles\Java\jdk* dirs and picks the last one that has
  a valid \bin\javac.exe. }
var
  F: TSearchRec;
  javaDir : String;
begin
  result := '';
  javaDir:=GetEnvironmentVariableUTF8('ProgramFiles')+'\Java';
  try
    if FindFirstUTF8(javaDir+'\jdk*', faAnyFile, F) = 0 then
    repeat
      if FileExistsUTF8(javaDir + '\' + F.Name + '\bin\javac.exe') then
        result := javaDir + '\'+ F.Name;
    until FindNextUTF8(F) <> 0;
  finally
    FindCloseUTF8(F);
  end;
end;

{$ELSE}
{$IFDEF DARWIN}
{===============================================================}
{=== OS X implementations ======================================}
{===============================================================}

{$ELSE}
{$IFDEF UNIX}
{===============================================================}
{=== Unix/Linux implementations ================================}
{===============================================================}

procedure TMainForm.Compile(const theDir : String; const theFile : String = '*.java');
{ theDir and theFile are assumed to be UTF8 }
var
  CompileProcess : TProcess;
  sl: TStringList;
  theFileName : String;
begin
  theFileName:=ExtractFileName(theFile);
  CompilerResultsForm.output_memo.Text:='Compiling '+ theFileName + '...';
  CompilerResultsForm.Show;

  SetCurrentDir(theDir);
  CompileProcess := TProcess.Create(nil);
  CompileProcess.Options := CompileProcess.Options + [poWaitOnExit];
  CompileProcess.CommandLine :='bash -c "javac '+theFile+' 2> '+TEMP_COMPILER_OUTPUT+'"';
  CompileProcess.Execute;
  CompileProcess.Free;
  self.UpdateFileLists();

  // see http://wiki.lazarus.freepascal.org/Multiplatform_Programming_Guide
  sl:=TStringList.Create;
  try
    sl.LoadFromFile(TEMP_COMPILER_OUTPUT);
    CompilerResultsForm.output_memo.Text:=SysToUTF8(sl.Text);
    if length(CompilerResultsForm.output_memo.Text) = 0 then
      CompilerResultsForm.output_memo.Text:=
        'Done compiling '+ theFileName + LineEnding +
        'No errors or warnings.';
  finally
    DeleteFile(TEMP_COMPILER_OUTPUT);
    sl.Free;
  end;
  CompilerResultsForm.FormStyle:=fsSplash;     { kludge to make sure results form is on top after compile is done }
  CompilerResultsForm.FormStyle:=fsNormal;     { end of kludge }
end;

procedure TMainForm.RunSelectedCompiledFile();
{ TODO : Consider merging with Windows version. }
var
  args : String;         { local buffer for getting command line arguments }
  theClass : String;     { stores the class name without extension }
  ExeProcess : TProcess;
  theCommands : String;
  theBashFile : String;
  theFile : TextFile;
  runIt : Boolean;
begin
  if self.compiled_filelistbox.SelCount = 1 then
  begin
    runIt:=true;                        { assume we will run the file }

    { get the filename relative to the project root, and then strip off the file extention }
    theClass:=StringReplace(self.compiled_filelistbox.FileName, self.ProjectRoot+DirectorySeparator, '', []);
    theClass:=ChangeFileExt(theClass, '');
    { Get commandline args from user if needed. }
    if CompareStr(self.m_argStr, ALWAYS_ENTER_ARGS_STR) = 0 then
    begin
      args:='';
      if not InputQuery(ExtractFileName(self.compiled_filelistbox.FileName) + ' arguments',
        'Command line arguments:', args) then
        runIt:=false
    end
    else
      args:=self.m_argStr;

    if runIt then
    begin
      theCommands :=
        '#!/bin/bash' + LineEnding +
        '# This is a temporary file created by jIDEE.' + LineEnding +
        '# It should have been deleted automatically.' + LineEnding +
        '# Feel free to delete this manually.' + LineEnding +
        'cd "' + self.ProjectRoot + '"' + LineEnding;
      theCommands +=
        'java -classpath "' + self.ProjectRoot + '" ' + theClass + ' ' + args + LineEnding;
      theCommands +=
        'echo' + LineEnding +
        'read -p "'+ PRESS_ENTER_TO_CLOSE +'"';
      { create batch file with above commands}
      theBashFile:=UTF8ToSys(self.ActiveDir+ DirectorySeparator +'jideeTemp.sh');
      try
        AssignFile(theFile, theBashFile);
        Rewrite(theFile);
        Write(theFile, UTF8ToConsole(theCommands));
        CloseFile(theFile);
      except
        on E: Exception do
          MessageDlg ('File Error',
                    E.Message+LineEnding+
                    'Possible reasons include:'+LineEnding+
                    ' * You do not have permission to write in this directory.'+LineEnding+
                    ' * The disc is full.'+LineEnding+
                    ' * Hardware or network failure.',
                    mtError, [mbOk],0);
      end;
      { execute batch file }
      ExeProcess := TProcess.Create(nil);
      ExeProcess.CommandLine := 'xterm -T '+ theClass + ' -e "bash ''' + theBashFile +'''"';
      ExeProcess.Options:=ExeProcess.Options+[poWaitOnExit];
      ExeProcess.Execute;
      ExeProcess.Free;
      { delete batch file }
      DeleteFile(theBashFile);
    end
  end
  else
    MessageDlg ('No file selected', 'You must first select a file.', mtError,
                 [mbOk],0)
end;

procedure TMainForm.ShowPreferencesForm();
begin
  PreferencesForm.editor_edit.Caption:=self.m_preferredEditor;
  PreferencesForm.filemanager_edit.Caption:=self.m_preferredFM;
  if PreferencesForm.ShowModal() = mrOK then
  begin
    self.m_preferredEditor:=PreferencesForm.editor_edit.Caption;
    self.m_preferredFM:=PreferencesForm.filemanager_edit.Caption;
  end;
end;

{$ENDIF}
{$ENDIF}
{$ENDIF}

initialization
  {$I main.lrs}

end.

